"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.CodeWriter = void 0;
var code_block_writer_1 = __importDefault(require("code-block-writer"));
var escape_1 = require("./escape");
var CodeWriter = /** @class */ (function (_super) {
    __extends(CodeWriter, _super);
    function CodeWriter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ranges = {};
        _this._texts = [];
        _this.getRanges = function () {
            return _this.ranges;
        };
        _this.recordRange = function (type, name) {
            if (!_this.ranges[type]) {
                _this.ranges[type] = {};
            }
            _this.ranges[type][name] = {
                // eslint-disable-next-line no-underscore-dangle
                line: _this._texts.join('').trim().split(_this.getOptions().newLine).length
            };
            return _this;
        };
        _this.writeEscapedString = function (str) {
            if (_this.getOptions().useSingleQuote) {
                return _this.write("'".concat((0, escape_1.escapeForSingleQuotes)(str), "'"));
            }
            return _this.write("\"".concat((0, escape_1.escapeForDoubleQuotes)(str), "\""));
        };
        /**
         * Safely escape and write a string as an object key.
         *
         */
        _this.writeObjectKey = function (str) {
            var useSingleQuote = _this.getOptions().useSingleQuote;
            var escaped = useSingleQuote ? (0, escape_1.escapeForSingleQuotes)(str) : (0, escape_1.escapeForDoubleQuotes)(str);
            // If this key doesn't start with an alpha character then we should always wrap it in quotes and
            // then run it through some escaping logic to make sure that it doesn't contain anything that
            // might break out of the quotes.
            if (!/^([A-Za-z]{1})/.test(str)) {
                return _this.write(useSingleQuote ? "'".concat(escaped, "'") : "\"".concat(escaped, "\""));
            }
            else if (escaped === str) {
                // If our key doesn't have any characters that might break out of quotes and requring escaping
                // but might have any non-alphanumeric characters in it that might not be able to be used as
                // a JS property key then we should wrap the key in quotes.
                if (/([^A-Za-z_0-9])/.test(str)) {
                    return _this.write(useSingleQuote ? "'".concat(str, "'") : "\"".concat(str, "\""));
                }
                // If our key doesn't need to be escaped then we don't need to wrap it in quotes.
                return _this.write(str);
            }
            return _this.write(useSingleQuote ? "'".concat(str, "'") : "\"".concat(str, "\""));
        };
        return _this;
    }
    return CodeWriter;
}(code_block_writer_1["default"]));
exports.CodeWriter = CodeWriter;
